{-------------------------------------------------------------------------------------------------}
{UE 10, modlisation des systmes biologiques et cologiques		}
{ Mcdle de Lokta-Vclterra avec variation sinusoidale de parametres. 	}
( Trois traces 2 x=f(l), y=f(l), espace des phases. 				}
{ Le prograrmue nest pas optimise mais rdig dams un souci de clart. }
{P. Coquillard}
{-------------------------------------------------------------------------------------------------}

Program PROIPRED;
Uses Crt, Graph, GRAPH2D;
      {Variables et constantes globalesl
const Lim = 30; 		{ Le nombre de pas de calcul}
var 	X, Y, k, k0, b, b0, a, e0, e, m, r, d, b, dt : real;
{-------------------------------------------------------------------------------------------------}
 {Procdure dinitialisation des variables }
{-------------------------------------------------------------------------------------------------}
Procedure initiale;
begin
      a0    :=- 4 * Pi;
      b0    := 0.3;
      e      := 1.0;
      m    := 2 * Pi:
      k0   := 1.07
      r     := 2 * Pi:
      X    := 0.5;
      Y    := 0.5;
      T    := 0.0r
      dt  :=0.01F
      phi :=0.5 r
end;
{-------------------------------------------------------------------------------------------------}
 ( Procdure cle calcul par intgration de Euler simple )
{-------------------------------------------------------------------------------------------------}
Procedure Euler;
begin
      b := b0 * (1 + 0.2 * sin(2 * Pi * t)); (parambres variables)
      a := a0 * (1 + 0.2 * sin(2 * Pi * (t - phi)));
      k := k0 * (1 + 0.4 * sin(2 * Pi * t));

      X := X + X* (r* (1-(X/k))-(a*Y/ (b+X)) ) *dt;
      Y := Y + Y* ((e*a*X) / (b+X) -m) *dt;
end;
{-------------------------------------------------------------------------------------------------}
 { Procdure de calcul par intgration de Runge-Kutta de 5e ordre }
{-------------------------------------------------------------------------------------------------}
Procedure R_Kutta;
var
DX1, DX2, DX3, DX4, DX5, DX6,
X1, X2, X3, X4, X5, DX :		real;
DY1, DY2, DY3, DY4, DY5, DY6,
Y1, Y2, Y3, Y4, Y5, DY : 		real;

begin
b:= b0 * (1 + 0.2 * sin(2 * Pi * t));
a:= a0 * (1 + 0.2 * sin(2 * Pi * ((t- phi)));
k:= k0 * (1 + 0.4 * sin(2 * Pi * t));

DX1 := dt*X*(r*(1-(X/k))(a*Y/(b+X)));
DY1 := dt*Y*( (e*a*X)/(b+X)-m);
X1   :=  x+DX1/4:
Y1   :=  Y+DY1/4;

DX2 := dt;*X1*(r* (1- (X1/k))  (a*Y/ (b+X1)) );
DY2 := dt*Y1* ( (e*a*X1) / (b+X1) m);
X2   :=  X + (DX1 / 8) + (DX2 / 8);
Y2   :=  Y + (DY1 / 8) + (DY2 /  8);

DX3  :=dt*X2*(r* (1- (X2/k)) - (a *Y2/(b+X2)) );
DY3   :=dt*Y2*((e*a*x2)/(b+x2)-m);
X3      := X - (DX2 / 2) + DX3;
Y3      := Y - (DY2 / 2) + DY3;

DX4   :=dt*X3*(r* (1- (X3/k)) - (a*Y3/ (b+X3)) );
DY4   :=dt*Y3* ( (e*a*X3)/(b+X3) -m);
X4      :=X - DX1*(3/16) + (DX4*9/16);
Y4      :=Y - DY1 * (3 / 16) + (DY4 * 9/16);

DX5   := dt * X4 * ( r * (1 - (X4 / k))-(a * Y4 / (b + X4)) );
DY5   := dt * Y4 * ( (e * a * X4) /(b + X4) - m );
X5     := X - (DX1 * 3 / 7) + (DX2 * 2 / 7) + (DX3 * 12 / 7) + (DX4 * 12 / 7);
Y5      :=Y - (DY1  * 3 / 7) + (DY2 * 2 / 7) + (DY3 * 12 / 7) + (DY4 * 12 / 7);

DX6   := dt * X5 * ( r * (1 - (X5 / k))  (a * Y5 / (b + X5)) );
DY6   := dt * Y5 * ( (e * a * X5) / (b + X5) - m );

DX    := ( (7 * DX1) + (32 * DX3) + (12 * DX4) + (32 * DX5) + (7 * DX6) )/90;
DY    := ( (7 * DY1) + (32 * DY3) + (12 * DY4) + (32 * DY5) + (7 * DY6) )/90;
X:= X + DX;
Y:= Y + DY;
end;
{-------------------------------------------------------------------------------------------------}
 { Trac dans l'espace des phases : effectue le trace de la population X }
{ en fonction de Y							 }
{-------------------------------------------------------------------------------------------------}
Procedure Phases;
begin
	Initiale;
	Fenetre (0.05, 1.1 , ~0.05, 1.1);	{dfinit la fentre sur l'univers du systme}
	Cloture (50, 250, 250, 450); 		{dfinit la taille et lemplacement de la}
						{projection de la fentre sur lcran}
	Axes; 					{trace des axes }
	Gradue (0.2, 0.2); 			 {dfinition des units de graduation }
	DeplaceEn (X,Y);
repeat
	t:=t+dt;
	R_Kutta; 					{ou Euler}
{Se1on les parametres en entre, le modele peut aboutir  des valeurs aberrantes telles que des
effectifs ngatifs, et mme des dbordements(overf1ow), D'o les tests suivants (attention  la
diffrence entre le ET (and) et ie OU (or) logique) }

	IF( (X > 0) and (Y > 0) ) then Tracevers(X,Y); 	{on ne trace que si valeurs positives}
until( (t > Lim) or (X<=O) or (Y<=0)); 			{si valeurs ngatives ou nulles on s'arrte}
end;
{-------------------------------------------------------------------------------------------------}
{ Trac de la population des proies en fonction du temps }
{-------------------------------------------------------------------------------------------------}
Procedure X_fonction_temps:
begin
      Initiale;
      Fenetre (~0.05, 20, -0.05, 1.lp
      Cloture (50, 500, 120, 220);
      Axes;
      Gradue (5, 0.2);
      DeplaceEn (t,X);
      repeat
      t:=t+dt;
      R_Kutta; 					{ou Euler}
      IF( (X > O) and (Y > 0)) then TraceVers(t,X);
      until ((t > Lim) or (X<=O) or (Y<=0));
end;
{-------------------------------------------------------------------------------------------------}
 {Trace de la population des prdateurs en fonction du temps }
{-------------------------------------------------------------------------------------------------}
Procedure Y_fonction_temps;
begin
      Initiale;
      Fenetre (-0.05, 20 , -0.05, 1.1);
      Cloture (50, 500, 10, 210);
      Axes;
      Gradue (5, 0.2);
      DeplaceEn (t,Y);
repeat
      t:=t+dt;
      R_Kutta;					{ou Euler}
      IF( (X > O) and (Y > 0)) then TraceVers (t,Y);
      until ((t > Lim) or (X<=O) or (Y<=O));
end;
{-------------------------------------------------------------------------------------------------}
 {Corps principal du programme					}
{-------------------------------------------------------------------------------------------------}

BEGIN
      EcranGraphique;	 {initialisation graphique}
      Phases; 		{tracs ...}
      X_fonction_temps;
      Y_fonction_temps;
      readln; 			{attente}
EcranTexte;			{on restore laffichage texte}
END.

